<?php
/*
Plugin Name: Inline Ajax More
Plugin URI: http://blog.hansa2k.de/inline-ajax-more/
Description: Display "(read more...)" inline on the main page using ajax instead of linking to a new page. Uses <a href="http://script.aculo.us/">scriptaculous</a> for FX. Based on inline-ajax-comment code by <a href="http://blog.kashou.net">Peter Kashou</a>.
Version: 1.1
Author: derDoc
Author URI: htp://blog.hansa2k.de/
*/ 

$current_ver = '1.1';
//$v_checker = 'http://derdoc.xerver.org/pub/wordpress/wp-content/download.php?newest';
$v_checker = 'http://web.me.com/derDoc/portfolio/self/IAM/iam.version';
$iam_hp = "http://derdocsblog.wordpress.com/iam/";

//add the filter
add_filter('the_content', 'IAM_ajaxify_more_link');

//add the options if they are not already set
if (!get_option('IAM_Installed')) 
	add_option('IAM_Installed', $current_ver, 'Set to current version of plugin that is installed', $autoload);
else 
	update_option('IAM_Installed', $current_ver);

if (!get_option('IAM_Apea'))
		add_option('IAM_Apea', 'Appear', 'Default effect to use for the appearing magic', $autoload);
if (!get_option('IAM_Fade'))
		add_option('IAM_Fade', 'Fade', 'Default effect to use for the dis-appearing magic', $autoload);
if (!get_option('IAM_Dur'))
		add_option('IAM_Dur', 6, 'Default Duration for all FX', $autoload);
if (!get_option('IAM_browscap'))
		add_option('IAM_browscap', 'disable', 'Browscap-backed JS-capa detection of Browser', $autoload);
if (!get_option('IAM_disable_JS'))
	add_option('IAM_disable_JS', 'disable', 'Disable JS detection - needed when Busy-XHTML contains quotes', $autoload);

$img_url = '<p align="center"><img src="' . get_settings('siteurl').'/wp-content/plugins/inline-ajax-more/working.gif' . '" alt="loading" /></p>';
if (!get_option('IAM_Busy'))
		add_option('IAM_Busy', $img_url, 'Default XHTML while loading', $autoload);

if (__('Read more') != 'Read more')
	$rm = __('Read more');
else
	$rm = 'Continue reading %s ...  &raquo;';
if (!get_option('IAM_More'))
		add_option('IAM_More', $rm, 'Default "Read More" link text', $autoload);


if (__('Read less') != 'Read less')
	$rl = __('Read less');
else
	$rl = '&laquo; Read less of %s ...';
if (!get_option('IAM_Less'))
		add_option('IAM_Less', $rl, 'Default "Read Less" link text', $autoload);


$IAM_no_js = false;


//and check if user has js capabilities only if enabled, for that disable error reporting temporarily
if (get_option('IAM_browscap') == "enable"){
	$old_erep = error_reporting(0);
	$browser = get_browser(null,true);
	//browscap exists so check, give only negative feedback, since we still have the <noscript> tag
	if (!isset($browser['javascript']) || $browser['javascript']===0 || $browser['javascript']===false)
		$IAM_no_js = true;
	error_reporting($old_erep);
}

function IAM_update() {
	if ( isset($_POST['IAM_Apea']) ) {
		update_option('IAM_Apea', $_POST['IAM_Apea']);
	}
	if ( isset($_POST['IAM_Fade']) ) {
		update_option('IAM_Fade', $_POST['IAM_Fade']);
	}
	if ( isset($_POST['IAM_Dur']) && is_numeric($_POST['IAM_Dur']) && $_POST['IAM_Dur'] > 0) {
		update_option('IAM_Dur', $_POST['IAM_Dur']);
	}
	if ( isset($_POST['IAM_Busy']) && !empty($_POST['IAM_Busy'])) {
		update_option('IAM_Busy', $_POST['IAM_Busy']);
	}
	if ( isset($_POST['IAM_More']) && !empty($_POST['IAM_More'])) {
		update_option('IAM_More', $_POST['IAM_More']);
	}
	if ( isset($_POST['IAM_Less']) && !empty($_POST['IAM_Less'])) {
		update_option('IAM_Less', $_POST['IAM_Less']);
	}
	if ( isset($_POST['IAM_browscap']) && !empty($_POST['IAM_browscap'])) {
		update_option('IAM_browscap', $_POST['IAM_browscap']);
	}
	if ( isset($_POST['IAM_disable_JS']) && !empty($_POST['IAM_disable_JS']))
		update_option('IAM_disable_JS', $_POST['IAM_disable_JS']);

}

function IAM_ajaxify_more_link($content) {
	global $more, $id, $IAM_no_js, $iam_hp, $current_ver;
	
	if ($IAM_no_js) 
		return $content;
	
	$title = the_title('','',false); 

	$apea = get_option('IAM_Apea');
	$fade = get_option('IAM_Fade');
	$dur  = get_option('IAM_Dur');
	$iam_dis_js = (get_option('IAM_disable_JS') == 'disable');
	if ($iam_dis_js)
		$busy = get_option('IAM_Busy');
	else
		$busy = strtr(stripslashes(get_option('IAM_Busy')),array('"'=>'',"'"=>""));
	
	$read_more  = get_option('IAM_More');
	$read_less  = get_option('IAM_Less');
	
	$page = get_settings('siteurl') .'/wp-content/plugins/inline-ajax-more/ajax-more.php';
	$ter = "false";
	
	//sprintf the title into the links
	if (strstr($read_more,'%')){
		$read_more = sprintf($read_more, $title);
	}

	if (strstr($read_less,'%')){
		$read_less = sprintf($read_less, $title);
	}

if ($iam_dis_js)
	$magic = "<!-- Inline Ajax More Plugin Section -->
			<!-- IAM Plug v{$current_ver} by derDoc @ $iam_hp -->
		<!-- IAM \"read more\" link -->
		<span id='show-inline-more-\${3}'>
			<a href='javascript:;' id='show-inline-more-link-\${3}' onmouseup='IAM_ajaxShowMore(\${3},\"$busy\",\"$page\",\"$apea\",$dur,\${TER}, \"\${1}\");'>
				$read_more
			</a>
		</span>

		<!-- IAM \"read less\" link 1-->
		<span id='hide-1-inline-more-\${3}' style='display: none;'>
			<a href='#post-\${3}' onmouseup='IAM_ajaxHideMore(\${3},\"$fade\",$dur); return true;'>
				$read_less
			</a>
		</span>

		<!-- IAM content -->
		<div id='inline-more-\${3}' style='display: none;'></div>

		<!-- IAM busy pic -->
		<span id='inline-more-notification-\${3}'></span>

		<!-- IAM \"read less\" link 2-->
		<span id='hide-2-inline-more-\${3}' style='display: none;'>
			<a href='#post-\${3}' onmouseup='IAM_ajaxHideMore(\${3},\"$fade\",$dur); return true;'>
				$read_less
			</a>
		</span>
	<!-- /Inline Ajax More Plugin Section -->\n";
else{
	//double-slash everything, and slash line-breaks 4 js write
	$magic = "<!-- Inline Ajax More Plugin Section -->\\
		<!-- IAM Plug v{$current_ver} by derDoc @ $iam_hp -->\\
		<!-- IAM \"read more\" link -->\\
		<span id=\"show-inline-more-\${3}\">\\
			<a href=\"javascript:;\" id=\"show-inline-more-link-\${3}\" onmouseup=\"IAM_ajaxShowMore(\${3},\\'$busy\\',\\'$page\\',\\'$apea\\',$dur,\${TER}, \\'\${1}\\');\">\\
				$read_more\\
			</a>\\
		</span>\\
\\
		<!-- IAM \"read less\" link 1-->\\
		<span id=\"hide-1-inline-more-\${3}\" style=\"display: none;\">\\
			<a href=\"#post-\${3}\" onmouseup=\"IAM_ajaxHideMore(\${3},\\'$fade\\',$dur); return true;\">\\
				$read_less\\
			</a>\\
		</span>\\
\\
		<!-- IAM content -->\\
		<div id=\"inline-more-\${3}\" style=\"display: none;\"></div>\\
\\
		<!-- IAM busy pic -->\\
		<span id=\"inline-more-notification-\${3}\"></span>\\
\\
		<!-- IAM \"read less\" link 2-->\\
		<span id=\"hide-2-inline-more-\${3}\" style=\"display: none;\">\\
			<a href=\"#post-\${3}\" onmouseup=\"IAM_ajaxHideMore(\${3},\\'$fade\\',$dur); return true;\">\\
				$read_less\\
			</a>\\
		</span>\\
	<!-- /Inline Ajax More Plugin Section -->";

	//and surround by script tag to allow execution only when JS is enabled
	$magic = "<script type='text/javascript'>
	document.write('" . $magic . "');
</script>
<noscript>
<a href='".get_permalink($id)."'>$read_more</a>
</noscript>";

}
	
	//only do something when in abstract mode
	if (strstr($content,'#more-') && !$more){
		$content = strtr(preg_replace('/<a href="(([^><#]+?)#more-(\d+))"( class="more-link")?>([^<]+)<\/a>/',$magic, $content),
							array('${TER}' => $ter)
						);
	}else if(strstr($content,'<!--2more2-->')){
		//hack to split off content after <!--2more2-->
		list($content,) = explode('<!--2more2-->', $content, 2);
		$content .= strtr($magic, array(
									'${1}' => get_permalink($id),
									'${3}' => $id,
									'${TER}' => $ter
								));
	
	}else if(strstr($content,' class="more-link"')){
		//the excerpt reloaded plugin
		$ter = "true";
		$content = preg_replace('/ class="more-link"><a href="([^<#]+?(#more-(\d+))?)" title="[^<]+?">([^<]+)<\/a>/',$magic,
							 (strtr($content,
									array(
										'${TER}' => $ter
									)
							))
						);
	
	}
	return $content;
}

function iam_header() {
	echo('<script src="' . get_settings('siteurl') . '/wp-content/plugins/inline-ajax-more/ajax-more.js" type="text/javascript"></script>'."\n");
	echo('<script src="' . get_settings('siteurl') . '/wp-content/plugins/inline-ajax-more/scriptaculous/lib/prototype.js" type="text/javascript"></script>'."\n");
	echo('<script src="' . get_settings('siteurl') . '/wp-content/plugins/inline-ajax-more/scriptaculous/src/scriptaculous.js?load=effects" type="text/javascript"></script>'."\n");
}

//add scripts to sitewide header
add_action('wp_head', 'iam_header');


// Add the options page.
add_action ('admin_menu', 'IAM_menu');

function IAM_menu() {
	//and add our page to the plugins page
	add_submenu_page('plugins.php', 'Inline Ajax More options', 'Inline Ajax More options', 5, 'inline-ajax-more.php', 'IAM_plugin_menu');
}


function check_browscap(){
	if (file_exists('/etc/php.ini'))
		$phpinifile = '/etc/php.ini';
	else if (file_exists('C:\\Windows\\php.ini'))
		$phpinifile = 'C:\\Windows\\php.ini';
		
	if (isset($phpinifile)){
		echo "<font color='green' size='-2'>php.ini found in '$phpinifile'</font><br>";

		$res = parse_ini_file($phpinifile);
		if(isset($res['browscap'])){
			echo "<font color='green' size='-2'>browscap directive set</font><br>";
			if (file_exists($res['browscap']))
				echo "<font color='green' size='-2'>browscap is installed & working</font><br>";
			else
				echo "<font color='red' size='-2'>browscap file not found! Download from <a href='http://browsers.garykeith.com/downloads.asp'>here</a></font><br>";
		
		}else
			echo "<font color='red' size='-2'>browscap directive not set! Set 'browscap' in $phpinifile to path of your browscap.ini</font><br>";
	}else
		echo "<font color='red' size='-2'>php.ini not found! Check 'open_basedir' restriction (on shared servers it most likely will be set)</font><br>";
	
	$old = error_reporting(0);
	$browser = get_browser(null, true);
	error_reporting($old);
	if (is_array($browser)){
		echo "<font color='green' size='-2'>get_browsercaps succeeded!</font><br>";
		return true;
	}else{
		echo "<font color='red' size='-2'>get_browsercaps failed!</font><br>";
		return false;
	}
}


function IAM_plugin_menu() {
global $v_checker, $current_ver, $iam_hp;

	if (isset($_POST['Submit'])){

?>
	<div id="message" class="updated fade">
		<p> <?php _e('plugin options have been updated') ?> </p>
	</div>

<?php
	}

$appear_fxs	=	array('Appear','BlindDown','SlideDown','Grow','Shake','Pulsate','Highlight');
$fade_fxs	=	array('Fade','BlindUp','SlideUp','Squish','Fold','Shrink','DropOut','Puff','SwitchOff');
$JS_dets	=	array('disable','enable');

$c_ver = get_option('IAM_Installed');
$ver = rtrim(@file_get_contents($v_checker));
$v_col = (($c_ver == $ver)?'green':'red');
if (empty($ver))
	$ver = "???";

?>

<div class="wrap">

<h2><?php _e('Inline Ajax More options'); ?></h2>
<form name="dofollow" action="" method="post">
  <input type="hidden" name="action" value="<?php IAM_update(); ?>" />
  <input type="hidden" name="page_options" value="'dofollow_timeout'" />
  <table width="700px" cellspacing="2" cellpadding="5" class="editform">
		
		<tr valign="top">
		<th scope="row"><?php _e('Default Options'); ?></th>
		<tr>
			<td>
				<select name="IAM_Apea" size="1"> 
				<?php foreach($appear_fxs as $fx)
				 		print ("<option" . ($fx==get_option('IAM_Apea')?' selected':'') . ">$fx</option>\n"); 
				 ?>
				</select>
			</td>
			<td>
				<label for="IAM_Apea"><?php _e('Appearing FX') ?></label>
			</td>
		</tr>
		<tr>	
			<td>
				<select name="IAM_Fade" size="1"> 
				<?php foreach($fade_fxs as $fx) 
				 		echo ("<option". ($fx==get_option('IAM_Fade')?' selected':'') . ">$fx</option>\n");
				 ?>
				</select>
			</td>
			<td>
				<label for="IAM_Fade"><?php _e('Dis-Appearing FX') ?></label>
			</td>
		</tr>
		<tr>	
			<td>
				<input name="IAM_Dur" type="text" size="2" value="<?php echo get_option('IAM_Dur') ?>" /> 
			</td>
			<td>
				<label for="IAM_Dur"><?php _e('Duration for FX') ?></label>
			</td>
		</tr>
		<tr>	
			<td>
				<input name="IAM_Busy" type="text" size="30" value='<?php echo stripslashes(get_option('IAM_Busy')) ?>' /> 
			</td>
			<td>
				<label for="IAM_Busy"><?php echo stripslashes(get_option('IAM_Busy')); _e('Busy XHTML'); echo ' - cannot contain any quotes, they get removed if no-JS detection w/ &lt;noscript&gt; tag is on -- sorry! <br />If your XHTML includes URLs that need to include special characters, please enter them urlencoded.' ?></label>
			</td>
		</tr>
		<tr>	
			<td>
				<select name="IAM_disable_JS" size="1"> 
				<?php foreach($JS_dets as $js) 
				 		echo ("<option". ($js==get_option('IAM_disable_JS')?' selected':'') . ">$js</option>\n");
				 ?>
				</select>
			</td>
			<td>
				<label for="IAM_disable_JS"><?php _e('"Javascript-disabled" detection with &lt;noscript&gt; tag - disable for Busy-XHTML that need to contain quotes (single and double).') ?></label>
			</td>
		</tr>
		<tr>	
			<td>
				<input name="IAM_More" type="text" size="30" value="<?php echo get_option('IAM_More') ?>" /> 
			</td>
			<td>
				<label for="IAM_More"><?php _e('"Read More" link text'); echo ' - replaces %s by title of post. Can be overriden by setting "Read more" in translation file' ?></label>
			</td>
		</tr>
		<tr>	
			<td>
				<input name="IAM_Less" type="text" size="30" value="<?php echo get_option('IAM_Less') ?>" /> 
			</td>
			<td>
				<label for="IAM_Less"><?php _e('"Read Less" link text'); echo ' - replaces %s by title of post. Can be overriden by setting "Read less" in translation file' ?></label>
			</td>
		</tr>
		<tr>	
			<td>
				<table>
				<tr>	
					<td>
		<?php 
				if (!check_browscap()){
				 	echo ("<script language='javascript'>
				 			document.dofollow.IAM_browscap.disabled=true;
				 			document.dofollow.IAM_browscap.selectedIndex=0;
				 		</script>\n");
				 	update_option('IAM_browscap', 'disable');
				 }else{
				 	echo ("<script language='javascript'>
				 		document.dofollow.IAM_browscap.disabled=false;</script>
				 	\n");
				 }
		?>
					</td>
					<td>
		<?php
				echo ("<select name='IAM_browscap' size='1'>\n");
					foreach($JS_dets as $bc) 
				 		echo ("<option". ($bc==get_option('IAM_browscap')?' selected':'') . ">$bc</option>\n");
				echo "</select><br />\n";
		?>
					</td>
				</tr>
				</table>
			</td>
			<td>
				<label for="IAM_browscap"><?php _e('Use browscap.ini file for JS-capa detection of user\'s browser, and disable plugin <b>only</b> when JS not supported') ?></label>
			</td>
		</tr>
	</table>

	<p class="submit"><input type="submit" name="Submit" value="<?php _e('Update Options') ?> &raquo;" /></p>

</form>
</div>

<div class="wrap">
	<p style="text-align: center;">You are running <em>Inline Ajax More</em> version <?php echo $c_ver; ?><br />
	The newest version is <font color="<?php echo($v_col); ?>"><?php echo($ver); ?></font><br />
	Check for plugin updates at the <a href="<?php echo($iam_hp); ?>" title="plugin homepage">inline ajax more</a> homepage.</p>
</div>

<?php } // this ends the admin page 
/*	Changelog
v0.1 (27.3.2006):
	-Initial version
	-basic stuff running
v0.5 (28.3.2006):
	-added options for duration and pic
	-changed wording of link to wordpress style
	-RegEx now correctly matches only link
v0.6 (30.3.2006, 0815h GMT):
	-fixed multiple clicking bug (Thomas Lee Elifritz), which was stupid JS error
               -> now correctly re-displays content without reloading it from the server (should actually have worked before?)
v0.7 (30.3.2006, 2300h GMT):
	-fixed incompatibility with Inline-ajax-comments plug, functions had same names (*doh*)
	-added hack to put a <!--more2--> on pages where <!--more--> tags get stripped out, and the content is shown instead (for the example)
v0.8 (2.4.2006, 1910h GMT):
	-fixed non-HTML characters malformed bug (thx Sebastian)
v0.9 (19.4.2006, 1735h GMT):
	-changed onMouseUp to onmouseup (validates better)
	-added 'read less' link at top
	-added some comments to added HTML
	-removed \n in <a> tag, so that it doesn't get screwed up by WP's format plug
	-i18n'ed 'read less'
	-<!-- more2 --> now displays correct title when used on a page
v0.9.4 (21.7.2006, 2020h GMT):
	-replaced scriptaculous 1.6 by 1.6.1
	-added support for TER (experimental)
v0.9.8 (14.10.2006, 0900h GMT):
	-replaced scriptaculous 1.6.1 by 1.6.4
	-added admin options for
		1) text of read more link - replaces %s with title
		2) text of read less link - replaces %s with title
		3) XHTML for pic instead of just pic URL
	-added checking for JS capa of browser... but can only tell if JS is supported not if its actually enabled, by using browscap file
		-> this needs the browscap.ini correctly installed and pointed to by php.ini or it wont work
	-added some try..catch to JS
	-should let browser handle-link click if something went wrong in loading-code
	-and gives user the option of going to perma-page if something went wrong while displaying later
	-if something goes wrong while hiding, a message appears
v0.9.9 (17.10.2006, 0600h GMT):
	-finalized document.write() JS surrounding of whole link - enables us to have a <noscript> section - that is displayed if JS is completely disabled
	-had to add IAM_disable_JS option to disable the whole JS surrounding, because it does not allow quotes in the Busy-XHTML, because of the way
		the document.write works in this case - so if it contains quotes (single|double), this option needs to be checked
	-had to do this by a select rather than a checkbox since IAM_update seems to get called regardless of actually updating
	-removed superfluous <img src=...> code in admin in description of Less and More link text
	-added temporarily disabling of error reporting for get_browser, so that PHP does not complain if 'brows_cap' directive is not set in php.ini
v1.0 (16.07.2007, 0333h GMT):
	-updated script.aculo.us to 1.7.1_beta3 (from 25.5.2007) w/ NEW prototype 1.5.1.1 (from 19.6.2007)
	-L183 added /...(class="more-link")?/ to REGEX search string, WP2.2 seems to incorp. TER already?
	-reversed logic of browscap checking, coz it used to fail when the browscap.ini wasnt installed
		-now it only disables JS when it is really sure, i.e. when get_browser succeeds and says the browsesr doesnt speak JS
	-had to change <!-- more2 --> to <!-- 2more2 --> coz WP2.2 now matches /<!--more(.*?)?-->/ as more tags
	-added Shake, Pulsate and Highlight to the appearing FX, though they are not appearing anything, they are more to "highlight" whats already there
	-now only loads the effects and not all of 100kb scriptaculous by using "?load=effects" in "<script src=..." statement
v1.0r01 (18.07.2007, 0058h GMT):
	-added function check_browscap() that tries to open and parse php.ini to find browscap directive and checks existence of browscap.ini
		-calls get_browser in the end and checks for meaningful return, if so it will enable a selection to enable the browscap check
	-is called in admin-options panel and gives feedback on findings
	-browscap is then only used if enabled in admin-panel
		-still uses only negative feedback, to not use JS only when browscap works and says that browser doesnt support
	-added option IAM_browscap that can only be set to true, when check_browscap returns true
	-if check_browscap returns false it will disable the selection and set IAM_browscap to false
	18.07.2007, 1415h GMT:
	-added version checker in admin panel
v1.1 (31.03.2010, 1035h GMT-8):
	-changed scriptaculous/prototype version to newest (1.6.1)
	-two small changes to make it work with newest WP version 2.9.2
	-moved HP and version check over to my new blog at derdocsblog.wordpress.com, resp. the file area at web.mac.com
	-if version string is not online, now defaults to ???

*/
?>
